; 1: 'This program was created by Alexey Uskov for PIC12f629
; 2: 'TA1243    Samsung RMUP74055WL
; 3: '     
; 4: '50 channel  807.25 MHz
; 5: '36 channel  591.25 MHz
; 6: '    1    ,    
; 7: 
; Compiled with: PIC Simulator IDE - Registered Copy v6.95
; Microcontroller model: PIC12F629
; Clock frequency: 4.0 MHz
	R0L EQU 0x020
	R0H EQU 0x021
	R1L EQU 0x022
	R2L EQU 0x024
	R2H EQU 0x025
	R4L EQU 0x028
	R4H EQU 0x029
	R0HL EQU 0x020
	R2HL EQU 0x024
	R4HL EQU 0x028
	SCL_PORT EQU 0x023
	SCL_BIT EQU 0x026
	SDA_PORT EQU 0x027
	SDA_BIT EQU 0x02A
;       The address of 'g' (byte) (global) is 0x02B
;       The address of 'a' (byte) (global) is 0x02C
;       The address of 'b' (byte) (global) is 0x02D
;       The address of 'd' (byte) (global) is 0x02E
;       The address of 'e' (byte) (global) is 0x02F
;       The address of 'sda' (bit) (global) is 0x005,5
;       The address of 'scl' (bit) (global) is 0x005,4
	ORG 0x0000
	BCF PCLATH,3
	BCF PCLATH,4
	GOTO L0004
	ORG 0x0004
	RETFIE
; User code start
L0004:
; 8: Dim a As Byte
; 9: Dim b As Byte
; 10: Dim d As Byte
; 11: Dim e As Byte
; 12: Dim g As Byte
; 13: Symbol sda = GPIO.5  'sda pin
; 14: Symbol scl = GPIO.4  'scl pin
; 15: ConfigPin GPIO.3 = Input
	BSF STATUS,RP0
	BSF TRISIO,3
; 16: ConfigPin GPIO.2 = Output
	BCF TRISIO,2
	BCF STATUS,RP0
; 17: g = 0
	CLRF 0x02B
; 18: GPIO.2 = 0
	BCF 0x005,2
; 19: 
; 20: 
; 21: main:
L0001:
; 22: 
; 23: 
; 24: Read 7, g  ' 
	MOVLW 0x07
	BSF STATUS,RP0
	MOVWF EEADR
	BSF EECON1,RD
	NOP
	MOVF EEDATA,W
	BCF STATUS,RP0
	MOVWF 0x02B
; 25: If g = 1 Then
	MOVF 0x02B,W
	SUBLW 0x01
	BTFSS STATUS,Z
	GOTO L0005
; 26: Gosub writing
	CALL L0003
; 27: Else
	GOTO L0006
L0005:
; 28: Gosub writing_data
	CALL L0002
; 29: Endif
L0006:
; 30: 
; 31: 
; 32: If GPIO.3 = 1 Then
	BTFSS 0x005,3
	GOTO L0007
; 33: WaitMs 100
	MOVLW 0x64
	MOVWF R0L
	CLRF R0H
	CALL W001
; 34: Endif
L0007:
; 35: WaitMs 100  '         200 
	MOVLW 0x64
	MOVWF R0L
	CLRF R0H
	CALL W001
; 36: 
; 37: 
; 38: If GPIO.3 = 1 Then
	BTFSS 0x005,3
	GOTO L0008
; 39: Read 7, g  '    (      EEPROM)
	MOVLW 0x07
	BSF STATUS,RP0
	MOVWF EEADR
	BSF EECON1,RD
	NOP
	MOVF EEDATA,W
	BCF STATUS,RP0
	MOVWF 0x02B
; 40: If g = 1 Then
	MOVF 0x02B,W
	SUBLW 0x01
	BTFSS STATUS,Z
	GOTO L0009
; 41: Write 7, 0  '    
	MOVLW 0x07
	BSF STATUS,RP0
	MOVWF EEADR
	MOVLW 0x00
	MOVWF EEDATA
	BSF EECON1,WREN
	MOVLW 0x55
	MOVWF EECON2
	MOVLW 0xAA
	MOVWF EECON2
	BSF EECON1,WR
L0010:	BTFSC EECON1,WR
	GOTO L0010
	BCF EECON1,WREN
	BCF STATUS,RP0
	BCF PIR1,EEIF
; 42: Else
	GOTO L0011
L0009:
; 43: Write 7, 1  '    
	MOVLW 0x07
	BSF STATUS,RP0
	MOVWF EEADR
	MOVLW 0x01
	MOVWF EEDATA
	BSF EECON1,WREN
	MOVLW 0x55
	MOVWF EECON2
	MOVLW 0xAA
	MOVWF EECON2
	BSF EECON1,WR
L0012:	BTFSC EECON1,WR
	GOTO L0012
	BCF EECON1,WREN
	BCF STATUS,RP0
	BCF PIR1,EEIF
; 44: Endif
L0011:
; 45: Endif
L0008:
; 46: 
; 47: '''''''''''''''''''''''''''''''''''''''
; 48: Read 7, g  '   
	MOVLW 0x07
	BSF STATUS,RP0
	MOVWF EEADR
	BSF EECON1,RD
	NOP
	MOVF EEDATA,W
	BCF STATUS,RP0
	MOVWF 0x02B
; 49: If g = 1 Then
	MOVF 0x02B,W
	SUBLW 0x01
	BTFSS STATUS,Z
	GOTO L0013
; 50: Gosub writing
	CALL L0003
; 51: Else
	GOTO L0014
L0013:
; 52: Gosub writing_data
	CALL L0002
; 53: Endif
L0014:
; 54: 
; 55: GPIO.2 = 0
	BCF 0x005,2
; 56: WaitMs 1000
	MOVLW 0xE8
	MOVWF R0L
	MOVLW 0x03
	MOVWF R0H
	CALL W001
; 57: GPIO.2 = 1
	BSF 0x005,2
; 58: WaitMs 100
	MOVLW 0x64
	MOVWF R0L
	CLRF R0H
	CALL W001
; 59: GPIO.2 = 0
	BCF 0x005,2
; 60: 
; 61: ASM:        sleep
	sleep
; 62: 
; 63: 
; 64: 
; 65: End  '    
L0015:	GOTO L0015
; 66: 
; 67: 
; 68: writing_data:
L0002:
; 69: ASM:        CLRF INTCON  '   
	CLRF INTCON
; 70: Read 2, d  '  PD1    Prog. Data Byte 1
	MOVLW 0x02
	BSF STATUS,RP0
	MOVWF EEADR
	BSF EECON1,RD
	NOP
	MOVF EEDATA,W
	BCF STATUS,RP0
	MOVWF 0x02E
; 71: Read 3, e  '  PD2    Prog. Data Byte 2
	MOVLW 0x03
	BSF STATUS,RP0
	MOVWF EEADR
	BSF EECON1,RD
	NOP
	MOVF EEDATA,W
	BCF STATUS,RP0
	MOVWF 0x02F
; 72: WaitMs 5
	MOVLW 0x05
	MOVWF R0L
	CLRF R0H
	CALL W001
; 73: I2CPrepare sda, scl
	MOVLW 0x05
	MOVWF SDA_PORT
	MOVLW 0x20
	MOVWF SDA_BIT
	BSF STATUS,RP0
	BCF TRISIO,5
	BCF STATUS,RP0
	MOVLW 0x05
	MOVWF SCL_PORT
	MOVLW 0x10
	MOVWF SCL_BIT
	BSF STATUS,RP0
	BCF TRISIO,4
	BCF STATUS,RP0
	CALL IC41
	CALL IC41
; 74: I2CStart
	CALL IC31
; 75: I2CSend 0xca  'Byte of addr of the slave device
	MOVLW 0xCA
	CALL IC01
; 76: WaitMs 1
	MOVLW 0x01
	MOVWF R0L
	CLRF R0H
	CALL W001
; 77: I2CSend 0xf8  'Control Byte 1
	MOVLW 0xF8
	CALL IC01
; 78: WaitMs 1
	MOVLW 0x01
	MOVWF R0L
	CLRF R0H
	CALL W001
; 79: I2CSend 0x7f  'Control Byte 2
	MOVLW 0x7F
	CALL IC01
; 80: WaitMs 1
	MOVLW 0x01
	MOVWF R0L
	CLRF R0H
	CALL W001
; 81: I2CSend d  'Prog. Data Byte 1 (0x2b)
	MOVF 0x02E,W
	CALL IC01
; 82: WaitMs 1
	MOVLW 0x01
	MOVWF R0L
	CLRF R0H
	CALL W001
; 83: I2CSend e  'Prog. Data Byte 2 (0xf4) (703.25 MHz)
	MOVF 0x02F,W
	CALL IC01
; 84: WaitMs 1
	MOVLW 0x01
	MOVWF R0L
	CLRF R0H
	CALL W001
; 85: I2CStop
	CALL IC41
; 86: GPIO.2 = 1
	BSF 0x005,2
; 87: WaitMs 100  ' ,    
	MOVLW 0x64
	MOVWF R0L
	CLRF R0H
	CALL W001
; 88: GPIO.2 = 0
	BCF 0x005,2
; 89: WaitMs 100
	MOVLW 0x64
	MOVWF R0L
	CLRF R0H
	CALL W001
; 90: GPIO.2 = 1
	BSF 0x005,2
; 91: WaitMs 100
	MOVLW 0x64
	MOVWF R0L
	CLRF R0H
	CALL W001
; 92: GPIO.2 = 0
	BCF 0x005,2
; 93: WaitMs 100
	MOVLW 0x64
	MOVWF R0L
	CLRF R0H
	CALL W001
; 94: GPIO.2 = 1
	BSF 0x005,2
; 95: WaitMs 100
	MOVLW 0x64
	MOVWF R0L
	CLRF R0H
	CALL W001
; 96: GPIO.2 = 0
	BCF 0x005,2
; 97: 
; 98: Return
	RETURN
; 99: 
; 100: 
; 101: 
; 102: writing:
L0003:
; 103: ASM:        CLRF INTCON  '   
	CLRF INTCON
; 104: Read 0, a  '  PD1    Prog. Data Byte 1
	MOVLW 0x00
	BSF STATUS,RP0
	MOVWF EEADR
	BSF EECON1,RD
	NOP
	MOVF EEDATA,W
	BCF STATUS,RP0
	MOVWF 0x02C
; 105: Read 1, b  '  PD2    Prog. Data Byte 2
	MOVLW 0x01
	BSF STATUS,RP0
	MOVWF EEADR
	BSF EECON1,RD
	NOP
	MOVF EEDATA,W
	BCF STATUS,RP0
	MOVWF 0x02D
; 106: WaitMs 5
	MOVLW 0x05
	MOVWF R0L
	CLRF R0H
	CALL W001
; 107: I2CPrepare sda, scl
	MOVLW 0x05
	MOVWF SDA_PORT
	MOVLW 0x20
	MOVWF SDA_BIT
	BSF STATUS,RP0
	BCF TRISIO,5
	BCF STATUS,RP0
	MOVLW 0x05
	MOVWF SCL_PORT
	MOVLW 0x10
	MOVWF SCL_BIT
	BSF STATUS,RP0
	BCF TRISIO,4
	BCF STATUS,RP0
	CALL IC41
	CALL IC41
; 108: I2CStart
	CALL IC31
; 109: I2CSend 0xca  'Byte of addr of the slave device
	MOVLW 0xCA
	CALL IC01
; 110: WaitMs 1
	MOVLW 0x01
	MOVWF R0L
	CLRF R0H
	CALL W001
; 111: I2CSend 0xf8  'Control Byte 1
	MOVLW 0xF8
	CALL IC01
; 112: WaitMs 1
	MOVLW 0x01
	MOVWF R0L
	CLRF R0H
	CALL W001
; 113: I2CSend 0x7f  'Control Byte 2
	MOVLW 0x7F
	CALL IC01
; 114: WaitMs 1
	MOVLW 0x01
	MOVWF R0L
	CLRF R0H
	CALL W001
; 115: I2CSend a  'Prog. Data Byte 1 (0x2b)
	MOVF 0x02C,W
	CALL IC01
; 116: WaitMs 1
	MOVLW 0x01
	MOVWF R0L
	CLRF R0H
	CALL W001
; 117: I2CSend b  'Prog. Data Byte 2 (0xf4) (703.25 MHz)
	MOVF 0x02D,W
	CALL IC01
; 118: WaitMs 1
	MOVLW 0x01
	MOVWF R0L
	CLRF R0H
	CALL W001
; 119: I2CStop
	CALL IC41
; 120: GPIO.2 = 1
	BSF 0x005,2
; 121: WaitMs 50  ' ,    
	MOVLW 0x32
	MOVWF R0L
	CLRF R0H
	CALL W001
; 122: GPIO.2 = 0
	BCF 0x005,2
; 123: WaitMs 50
	MOVLW 0x32
	MOVWF R0L
	CLRF R0H
	CALL W001
; 124: GPIO.2 = 1
	BSF 0x005,2
; 125: WaitMs 50
	MOVLW 0x32
	MOVWF R0L
	CLRF R0H
	CALL W001
; 126: GPIO.2 = 0
	BCF 0x005,2
; 127: WaitMs 50
	MOVLW 0x32
	MOVWF R0L
	CLRF R0H
	CALL W001
; 128: GPIO.2 = 1
	BSF 0x005,2
; 129: WaitMs 50
	MOVLW 0x32
	MOVWF R0L
	CLRF R0H
	CALL W001
; 130: GPIO.2 = 0
	BCF 0x005,2
; 131: 
; 132: Return
	RETURN
; 133: 
; 134: 
; End of user code
L0016:	GOTO L0016
; Waitms Routine
W001:	MOVF R0L,F
	BTFSC STATUS,Z
	GOTO W002
	CALL W003
	DECF R0L,F
	NOP
	NOP
	NOP
	NOP
	NOP
	GOTO W001
W002:	MOVF R0H,F
	BTFSC STATUS,Z
	RETURN
	CALL W003
	DECF R0H,F
	DECF R0L,F
	GOTO W001
W003:	MOVLW 0x0C
	MOVWF R2H
W004:
	DECFSZ R2H,F
	GOTO W004
	NOP
	NOP
	MOVLW 0x12
	MOVWF R1L
W005:
	DECFSZ R1L,F
	GOTO W006
	CALL W007
	CALL W007
	NOP
	NOP
	RETURN
W006:
	CALL W007
	GOTO W005
W007:	MOVLW 0x0D
	MOVWF R2L
W008:
	DECFSZ R2L,F
	GOTO W008
	NOP
	RETURN
; Delay Routine Byte
; minimal routine execution time: 8s
; routine execution time step: 3s
; maximal routine execution time: 770s
DL01:
	DECFSZ R4L,F
	GOTO DL01
	RETURN
; Delay Routine Word
; minimal routine execution time: 15s
; routine execution time step: 10s
; maximal routine execution time: 655365s
DL02:
	MOVLW 0x01
	SUBWF R4L,F
	CLRW
	BTFSS STATUS,C
	ADDLW 0x01
	SUBWF R4H,F
	BTFSS STATUS,C
	RETURN
	GOTO DL02
; I2CWrite Routine
IC01:	MOVWF R0L
	MOVLW 0x08
	MOVWF R0H
IC02:	RLF R0L,F
	BTFSC STATUS,C
	CALL IC20
	BTFSS STATUS,C
	CALL IC21
	CALL IC22
	CALL IC23
	DECFSZ R0H,F
	GOTO IC02
	CALL IC24
	CALL IC03
	CALL IC25
	CALL IC21
	RETURN
IC03:
	CALL IC22
	MOVF SDA_PORT,W
	MOVWF FSR
	MOVF SDA_BIT,W
	ANDWF INDF,W
	ADDLW 0xFF
	CALL IC23
	RETURN
IC31:
	CALL IC21
	CALL IC23
	GOTO IC29
IC41:
	CALL IC22
	CALL IC20
	GOTO IC29
IC20:	MOVF SDA_PORT,W
	MOVWF FSR
	MOVF SDA_BIT,W
	IORWF INDF,F
	GOTO IC28
IC21:	MOVF SDA_PORT,W
	MOVWF FSR
	COMF SDA_BIT,W
	ANDWF INDF,F
	GOTO IC28
IC22:	MOVF SCL_PORT,W
	MOVWF FSR
	MOVF SCL_BIT,W
	IORWF INDF,F
	GOTO IC28
IC23:	MOVF SCL_PORT,W
	MOVWF FSR
	COMF SCL_BIT,W
	ANDWF INDF,F
	GOTO IC28
IC28:	BSF FSR,7
	COMF INDF,W
	BCF FSR,7
	ANDWF INDF,F
IC29:
	NOP
	RETURN
IC24:	MOVF SDA_PORT,W
	MOVWF FSR
	BSF FSR,7
	MOVF SDA_BIT,W
	IORWF INDF,F
	RETURN
IC25:	MOVF SDA_PORT,W
	MOVWF FSR
	BSF FSR,7
	COMF SDA_BIT,W
	ANDWF INDF,F
	RETURN
; End of listing
	END
